%  Copyright 2010 Carlos Gonzalez-Aguado
%
%  This file is part of the SAMPLE CODE for the following paper:
%  Bruche, M., Gonzalez-Aguado, C. "Recovery Rates, Default Probabilities, and the Credit Cycle"
%  Journal of Banking and Finance 34(4), 2010, 713-723.
%  
%  SAMPLE CODE is free software: you can redistribute it and/or modify it under
%  the terms of the GNU General Public License as published by the Free
%  Software Foundation, either version 3 of the License, or (at your option)
%  any later version.
%  
%  SAMPLE CODE is distributed in the hope that it will be useful, but WITHOUT
%  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
%  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
%  more details.
%  
%  You should have received a copy of the GNU General Public License along with
%  SAMPLE CODE.  If not, see <http://www.gnu.org/licenses/>.


function [x,flik,hes,aic,bic] = maxiprogr(drcyc,drmac,rrcyc,rrmac,rrind)

% Declare globals
global dr_cycle dr_macro rr_cycle rr_macro rr_ind n

% Set values for global variables 
dr_cycle = drcyc;
dr_macro = drmac;
rr_cycle = rrcyc;
rr_macro = rrmac;
rr_ind = rrind;

% Given the arguments of the function, readapt the data matrices
get_dr;
get_rr;
get_pos;

% Get initial conditions
x0 = get_ini(dr_cycle,rr_cycle,dr_macro,rr_macro,rr_ind);

% Maximize the likelihood function (routine 'lik')
[x,flik,ef,op,g,hes] = fminunc(@lik,x0);
flik = -flik;
aic = 2*(size(x,1) - flik);
bic = (size(x,1)*log(n) - 2*flik) / n;
