%  Copyright 2010 Carlos Gonzalez-Aguado
%
%  This file is part of the SAMPLE CODE for the following paper:
%  Bruche, M., Gonzalez-Aguado, C. "Recovery Rates, Default Probabilities, and the Credit Cycle"
%  Journal of Banking and Finance 34(4), 2010, 713-723.
%  
%  SAMPLE CODE is free software: you can redistribute it and/or modify it under
%  the terms of the GNU General Public License as published by the Free
%  Software Foundation, either version 3 of the License, or (at your option)
%  any later version.
%  
%  SAMPLE CODE is distributed in the hope that it will be useful, but WITHOUT
%  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
%  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
%  more details.
%  
%  You should have received a copy of the GNU General Public License along with
%  SAMPLE CODE.  If not, see <http://www.gnu.org/licenses/>.


% FUNCTION TO DO Q-Q PLOTS (MAYBE IT SHOULD COMPUTE SOME NUMBER TOO)

sas = 1000;
aaa = linspace(0,1,sas);

figure;
% Upturn
subplot(2,1,1)
plot(aaa,aaa,'Color','r')
hold on
    % Static model
    qqq = zeros(sas,1);
    for i = 1:sas
        qqq(i) = sum(zsta_up < i/sas) / size(zsta_up,1);
    end
    plot(aaa,qqq,'--b')
    % Dynamic model
    qqq = zeros(sas,1);
    for i = 1:sas
        qqq(i) = sum(zcyc_up < i/sas) / size(zcyc_up,1);
    end
    plot(aaa,qqq,'-k')

% Downturn
subplot(2,1,2)
plot(aaa,aaa,'Color','r')
hold on
    % Static model
    qqq = zeros(sas,1);
    for i = 1:sas
        qqq(i) = sum(zsta_dw < i/sas) / size(zsta_dw,1);
    end
    plot(aaa,qqq,'--b')
    % Dynamic model
    qqq = zeros(sas,1);
    for i = 1:sas
        qqq(i) = sum(zcyc_dw < i/sas) / size(zcyc_dw,1);
    end
    plot(aaa,qqq,'-k')    

